REM Sample program to search with Dir$ function. v1.0a QB45 source PD 2025.

' declare subroutines.
DECLARE SUB TreeDirectory (Directory AS STRING, Filename AS STRING)
DECLARE SUB CheckFilename (Filename1$, Filename2$, Match%)
DECLARE SUB Dot.Display2 (VarD%, VarE%, VarF!, Var$)

REM $DYNAMIC
CONST Version = "v1.0a"

' arrays to store filenames in search function.
DIM SHARED Directories(1) AS STRING
DIM SHARED Filenames(1) AS STRING

' lines in arrays.
DIM SHARED MaxDirs AS LONG
DIM SHARED MaxFiles AS LONG
DIM SHARED Restart AS INTEGER

' specify slash in Win/Linux/OSX
DIM SHARED DirChar AS STRING * 1
DIM SHARED DirChar2 AS STRING * 2
DIM SHARED DirChar3 AS STRING * 3

' settings for file output.
DIM SHARED DisplayOutput AS INTEGER
DIM SHARED WriteOutput AS INTEGER
DIM SHARED WriteFile AS STRING

' values for dot display.
DIM SHARED VarD AS INTEGER
DIM SHARED VarE AS INTEGER
DIM SHARED VarF AS SINGLE
CONST DotChar = "."
CONST DotCount = 5

' temp file variables.
DIM SHARED SubDirectory AS STRING
DIM Directory AS STRING
DIM Filename AS STRING
DIM SHARED Match AS INTEGER
DIM SHARED CaseSensitive

' counters and temp variables.
DIM X AS STRING * 1, Z AS LONG
DIM C AS INTEGER, D AS INTEGER

' init screen.
DIM t1 AS SINGLE, Q AS INTEGER

' assign timer traps.
ON TIMER(1) GOSUB TimerTrap
TIMER ON

' store directory slashs.
DirChar = "\": DirChar2 = ".\": DirChar3 = "..\"

' start input loop.
ON ERROR GOTO ErrorRoutine
Start.Loop:
Restart = 0
MaxDirs = 0
MaxFiles = 0

' setup all search variables.
COLOR 15
PRINT "File Search "; Version$
PRINT "Enter dirspec(" + DirChar + "Path" + DirChar + ")"; : INPUT Directory
PRINT "Enter dirmatch(*)"; : INPUT SubDirectory
PRINT "Enter filematch(*.*)"; : INPUT Filename
IF SubDirectory = "" THEN SubDirectory = "*"
IF Directory = "" THEN Directory = CURDIR$
IF RIGHT$(Directory, 1) <> DirChar THEN Directory = Directory + DirChar
IF Filename = "" THEN Filename = "*.*"
PRINT "Searching: "; Directory; Filename
PRINT "Start search:";
DO WHILE INKEY$ = "": LOOP
PRINT
DisplayOutput = -1 ' default to display files.

' get display option.
PRINT "Display output(y/n)?";
X$ = ""
DO
   X$ = INKEY$
   IF LCASE$(X$) = "n" THEN PRINT "n": DisplayOutput = 0: EXIT DO
   IF LCASE$(X$) = "y" THEN PRINT "y": DisplayOutput = -1: EXIT DO
LOOP

' get display option.
PRINT "Case-Sensitive(y/n)?";
X$ = ""
DO
   X$ = INKEY$
   IF LCASE$(X$) = "n" THEN PRINT "n": CaseSensitive = 0: EXIT DO
   IF LCASE$(X$) = "y" THEN PRINT "y": CaseSensitive = -1: EXIT DO
LOOP

' get output file.
PRINT "Write output to file(y/n)?";
X$ = ""
DO
   X$ = INKEY$
   IF LCASE$(X$) = "n" THEN PRINT "n": EXIT DO
   IF LCASE$(X$) = "y" THEN
      PRINT "y"
      PRINT "Enter filename";
      INPUT WriteFile$
      IF LEN(WriteFile$) THEN
         IF DIR$(WriteFile$) <> "" THEN
            PRINT "File exists. Overwrite(y/n)?";
            X$ = ""
            DO
               X$ = INKEY$
               IF LCASE$(X$) = "y" THEN PRINT "y": EXIT DO
               IF LCASE$(X$) = "n" THEN PRINT "n": GOTO NextLoop
            LOOP
         END IF
         WriteOutput = -1
         CLOSE
         OPEN WriteFile$ FOR OUTPUT AS #1
      END IF
      EXIT DO
   END IF
LOOP

NextLoop:
' start loading dirs and files.
COLOR 15
IF DisplayOutput = 0 THEN
   PRINT "Loading files";
END IF
COLOR 14
VarD% = 0
VarE% = 0
VarF! = TIMER
CALL TreeDirectory(Directory, Filename)

' check output type.
IF POS(0) > 1 THEN PRINT
COLOR 15
IF DisplayOutput = -1 THEN
   PRINT "Dirs:"; MaxDirs; " Files:"; MaxFiles
END IF
IF DisplayOutput = 0 THEN
   PRINT "Files written to array."
END IF

' check dir display.
PRINT "Display dir array(y/n)?";
C = 0
X$ = ""
DO
   X$ = INKEY$
   IF LCASE$(X$) = "n" THEN PRINT : EXIT DO
   IF LCASE$(X$) = "y" THEN
      PRINT
      ' sort dirs.
      PRINT "Sorting"; MaxDirs; "dirs";
      GOSUB SortDirs
      PRINT
      C = 1
      D = 0
      FOR Z = 1 TO MaxDirs
         COLOR 14
         PRINT Directories(Z)
         C = C + 1
         IF C >= 24 THEN
            C = 0
            IF D = 0 THEN
               COLOR 15
               PRINT "-more(y/n/c)-";
               X$ = ""
               DO
                  X$ = INKEY$
                  IF X$ = "?" THEN
                     PRINT
                     PRINT " n = no": PRINT " y = yes": PRINT " c = continuous"
                     PRINT "-more(y/n/c)-";
                  END IF
                  IF LCASE$(X$) = "n" THEN PRINT : GOTO NextDir
                  IF LCASE$(X$) = "y" THEN PRINT : EXIT DO
                  IF LCASE$(X$) = "c" THEN D = -1: PRINT : EXIT DO
               LOOP
            END IF
         END IF
      NEXT
      EXIT DO
   END IF
LOOP
NextDir:

' check file display.
COLOR 15
PRINT "Display file array(y/n)?";
C = 0
X$ = ""
DO
   X$ = INKEY$
   IF LCASE$(X$) = "n" THEN PRINT : EXIT DO
   IF LCASE$(X$) = "y" THEN
      PRINT
      ' sort files.
      PRINT "Sorting"; MaxFiles; "files";
      GOSUB SortFiles
      PRINT
      C = 1
      D = 0
      FOR Z = 1 TO MaxFiles
         COLOR 14
         PRINT Filenames(Z)
         C = C + 1
         IF C >= 24 THEN
            C = 0
            IF D = 0 THEN
               COLOR 15
               PRINT "-more(y/n/c)-";
               X$ = ""
               DO
                  X$ = INKEY$
                  IF X$ = "?" THEN
                     PRINT
                     PRINT " n = no": PRINT " y = yes": PRINT " c = continuous"
                     PRINT "-more(y/n/c)-";
                  END IF
                  IF LCASE$(X$) = "n" THEN PRINT : GOTO Nextfile
                  IF LCASE$(X$) = "y" THEN PRINT : EXIT DO
                  IF LCASE$(X$) = "c" THEN D = -1: PRINT : EXIT DO
               LOOP
            END IF
         END IF
      NEXT
      EXIT DO
   END IF
LOOP
Nextfile:

' check restart.
COLOR 15
PRINT "Start search again(y/n)?";
X$ = ""
DO
   X$ = INKEY$
   IF LCASE$(X$) = "n" THEN PRINT : EXIT DO
   IF LCASE$(X$) = "y" THEN PRINT : Restart = -1: GOTO Start.Loop
LOOP

' exit program.
TIMER OFF
COLOR 7
PRINT "Now exiting File Search."
END

' shell sort.
SortFiles:
DIM Num AS LONG, Span AS LONG
DIM Start AS LONG, Element AS LONG
DIM Sort.Column1 AS STRING
DIM Sort.Column2 AS STRING
Num = MaxFiles
Span = INT(Num / 2)
DO WHILE Span > 0
   FOR Start = Span TO Num - 1
      FOR Element = (Start - Span + 1) TO 1 STEP -Span
         Sort.Column1$ = Filenames(Element)
         Sort.Column2$ = Filenames(Element + Span)
         IF Sort.Column1$ <= Sort.Column2$ THEN
            EXIT FOR
         END IF
         SWAP Filenames(Element), Filenames(Element + Span)
      NEXT
   NEXT
   Span = INT(Span / 2)
LOOP
RETURN

' shell sort.
SortDirs:
DIM Num2 AS LONG, Span2 AS LONG
DIM Start2 AS LONG, Element2 AS LONG
DIM Sort.Column1x AS STRING
DIM Sort.Column2x AS STRING
Num2 = MaxDirs
Span2 = INT(Num2 / 2)
DO WHILE Span2 > 0
   FOR Start2 = Span2 TO Num2 - 1
      FOR Element2 = (Start2 - Span2 + 1) TO 1 STEP -Span2
         Sort.Column1x$ = Directories(Element2)
         Sort.Column2x$ = Directories(Element2 + Span2)
         IF Sort.Column1x$ <= Sort.Column2x$ THEN
            EXIT FOR
         END IF
         SWAP Directories(Element2), Directories(Element2 + Span2)
      NEXT
   NEXT
   Span2 = INT(Span2 / 2)
LOOP
RETURN

ErrorRoutine:
IF ERR = 5 OR ERR = 53 THEN RESUME NEXT ' sometimes file not found.
IF POS(0) > 1 THEN PRINT
PRINT "Critical error "; ERR; " line"; ERL
COLOR 15
PRINT "Enter(R)esume same/(N)resume next/(Q)uit:";
X$ = ""
DO
   X$ = INKEY$
   IF LCASE$(X$) = "r" THEN RESUME
   IF LCASE$(X$) = "n" THEN RESUME NEXT
   IF LCASE$(X$) = "q" THEN EXIT DO
LOOP
COLOR 7
END

TimerTrap:
DIM L AS INTEGER, M AS INTEGER
L = CSRLIN: M = POS(0)
COLOR 15
LOCATE 25, 1, 1
PRINT "FILEDIR "; DATE$ + " " + TIME$ + " " + Version$;
LOCATE L, M, 1
RETURN


' check filename1 matches in filename2 using ? and * and ^ characters.
SUB CheckFilename (Filename1$, Filename2$, Match%)
   DIM Length1 AS INTEGER, Length2 AS INTEGER
   DIM Not.Include AS STRING * 1
   Filename2$ = LTRIM$(RTRIM$(Filename2$))
   Match% = -1 ' assume mask matches filename2.
   Length1 = 1
   Length2 = 1
   DO
      ' global replacement.
      IF MID$(Filename1$, Length1, 1) = "*" THEN
         DO
            Length1 = Length1 + 1
            IF Length1 > LEN(Filename1$) THEN
               EXIT SUB
            END IF
            ' global replacement followed by exclusion character.
            ' searches remaining string until exclusion character found or not.
            IF MID$(Filename1$, Length1, 1) = "^" THEN
               Length1 = Length1 + 1
               Not.Include$ = MID$(Filename1$, Length1, 1)
               DO
                  IF Not.Include$ <> MID$(Filename2$, Length2, 1) THEN
                     Length2 = Length2 + 1
                  ELSE
                     Match% = 0
                     EXIT SUB
                  END IF
                  IF Length2 > LEN(Filename2$) THEN
                     EXIT SUB
                  END IF
               LOOP
            END IF
            ' global replacement followed by ? or another *
            ' skips to next character.
            IF MID$(Filename1$, Length1, 1) <> "*" THEN
               IF MID$(Filename1$, Length1, 1) <> "?" THEN
                  EXIT DO
               END IF
            END IF
         LOOP
         ' global replacement.
         ' searches for next matching character.
         DO
            IF MID$(Filename1$, Length1, 1) = MID$(Filename2$, Length2, 1) THEN
               EXIT DO
            ELSE
               Length2 = Length2 + 1
            END IF
            IF Length2 > LEN(Filename2$) THEN
               EXIT DO
            END IF
         LOOP
      ELSE
         ' character replacement.
         ' matches any next character.
         IF MID$(Filename1$, Length1, 1) = "?" THEN
            Length1 = Length1 + 1
            Length2 = Length2 + 1
         ELSE
            ' exclusion character.
            ' checks next character unmatched.
            IF MID$(Filename1$, Length1, 1) = "^" THEN
               Length1 = Length1 + 1
               Not.Include$ = MID$(Filename1$, Length1, 1)
               IF Not.Include$ <> MID$(Filename2$, Length2, 1) THEN
                  Length1 = Length1 + 1
                  Length2 = Length2 + 1
               ELSE
                  Match% = 0
                  EXIT DO
               END IF
            ELSE
               ' matches next character.
               IF MID$(Filename1$, Length1, 1) = MID$(Filename2$, Length2, 1) THEN
                  Length1 = Length1 + 1
                  Length2 = Length2 + 1
               ELSE
                  Match% = 0
                  EXIT DO
               END IF
               ' check string lengths.
               IF Length1 > LEN(Filename1$) THEN
                  IF Length2 <= LEN(Filename2$) THEN
                     Match% = 0
                  END IF
                  EXIT DO
               END IF
            END IF
         END IF
      END IF
   LOOP
END SUB

' make row of dots.
SUB Dot.Display2 (VarA%, VarB%, VarF!, Var$)
   ' check display timer
   DIM VarG AS SINGLE, VarZ AS INTEGER
   VarG! = TIMER - VarF!
   IF VarG! < 0! THEN VarG! = VarG! + 86400!
   IF VarG! >= 1! THEN
      VarF! = TIMER
      IF VarA% = 0 THEN
         VarB% = VarB% + 1
         PRINT DotChar;
         IF VarB% = DotCount THEN
            VarA% = -1
            VarB% = 0
         END IF
      ELSE
         VarB% = VarB% + 1
         FOR VarZ = 1 TO LEN(DotChar)
            GOSUB Back.Space
            PRINT " ";
            GOSUB Back.Space
         NEXT
         IF VarB% = DotCount THEN
            VarA% = 0
            VarB% = 0
         END IF
      END IF
   END IF
   EXIT SUB
   ' back one dot
Back.Space:
   IF POS(0) > 1 THEN
      LOCATE CSRLIN, POS(0) - 1, 0
      PRINT " ";
      LOCATE CSRLIN, POS(0) - 1, 1
   END IF
   RETURN
END SUB

' recursively search directories.
SUB TreeDirectory (Directory AS STRING, Filename AS STRING)
   DIM Entry(0 TO 0) AS STRING, N AS LONG
   DIM Filename1 AS STRING, Filename2 AS STRING
   DIM I AS LONG, E AS STRING, Var AS STRING
   ' recursively exit subroutine.
   IF Restart = -2 THEN
      EXIT SUB
   END IF
   ' restart arrays and values.
   IF Restart THEN
      I = 0: N = 0
      MaxFiles = 0
      MaxDirs = 0
      Restart = 0 ' restart restart!
   END IF
   ' start search
   E = DIR$(Directory)
   DO
      IF INKEY$ = CHR$(27) THEN Restart = -2: EXIT SUB
      IF E <> DirChar2 AND E <> DirChar3 THEN
         Match% = -1
         IF RIGHT$(E, 1) = DirChar THEN
            GOSUB CheckDir
         END IF
         IF Match% THEN
            Entry(N) = E
            N = N + 1
            IF N > UBOUND(Entry) THEN
               REDIM PRESERVE Entry(0 TO N) AS STRING
            END IF
         END IF
      END IF
      ' continue search
      E = DIR$
      CALL Dot.Display2(VarD%, VarE%, VarF!, E)
      IF Restart = -2 THEN
         EXIT SUB
      END IF
   LOOP WHILE LEN(E) > 0
   ' store directories.
   IF WriteOutput THEN
      PRINT #1, Directory
   END IF
   IF DisplayOutput THEN
      IF POS(0) > 1 THEN
         PRINT
      END IF
      COLOR 14
      PRINT "Dir: "; Directory
   END IF
   MaxDirs = MaxDirs + 1
   REDIM PRESERVE Directories(MaxDirs) AS STRING
   Directories(MaxDirs) = Directory
   ' search filenames.
   DO WHILE I < N
      IF INKEY$ = CHR$(27) THEN Restart = -2: EXIT DO
      Var$ = Entry(I)
      CALL Dot.Display2(VarD%, VarE%, VarF!, Var$)
      IF Var$ <> DirChar2 AND Var$ <> DirChar3 THEN
         IF RIGHT$(Entry(I), 1) <> DirChar THEN
            GOSUB CheckFile
            IF Match% THEN
               IF WriteOutput THEN
                  PRINT #1, Directory + Entry(I)
               END IF
               IF DisplayOutput THEN
                  IF POS(0) > 1 THEN
                     PRINT
                  END IF
                  COLOR 14
                  PRINT "File: "; Directory + Entry(I)
               END IF
               MaxFiles = MaxFiles + 1
               REDIM PRESERVE Filenames(MaxFiles) AS STRING
               Filenames(MaxFiles) = Directory + Entry(I)
            END IF
         END IF
         ' recurse directories.
         IF Entry(I) <> DirChar2 AND Entry(I) <> DirChar3 AND RIGHT$(Entry(I), 1) = DirChar THEN
            CALL TreeDirectory(Directory + Entry(I), Filename)
         END IF
      END IF
      I = I + 1
      IF Restart = -2 THEN
         EXIT SUB
      END IF
   LOOP
   EXIT SUB
   ' pattern match filename (sometimes *.*)
   ' also case-sensitive for Linux/OSX
CheckFile:
   ' store case-sensitive filenames.
   IF CaseSensitive THEN
      Filename1$ = Filename$
      Filename2$ = Entry(I)
   ELSE
      Filename1$ = UCASE$(Filename$)
      Filename2$ = UCASE$(Entry(I))
   END IF
   ' compare files with pattern matching.
   CALL CheckFilename(Filename1$, Filename2$, Match%)
   RETURN
   ' pattern match directory (not always *.*)
   ' also case-sensitive for Linux/OSX
CheckDir:
   ' store case-sensitive filenames.
   IF CaseSensitive THEN
      Filename1$ = SubDirectory$
      Filename2$ = E
   ELSE
      Filename1$ = UCASE$(SubDirectory$)
      Filename2$ = UCASE$(E)
   END IF
   ' compare dirs with pattern matching.
   IF RIGHT$(Filename2$, 1) = DirChar THEN Filename2$ = LEFT$(Filename2$, LEN(Filename2$) - 1)
   IF LEFT$(Filename2$, 1) = DirChar THEN Filename2$ = MID$(Filename2$, 2)
   CALL CheckFilename(Filename1$, Filename2$, Match%)
   RETURN
END SUB

